default:
  image: {{DOCKER_AWS_CLI_IMG}}

include:
  - remote: {{CI_FILES_DOMAIN}}/common/build.yml
  - remote: {{CI_FILES_DOMAIN}}/common/deploy.yml

stages:
  - build
  - deploy

variables:
  CLIENT_PATH: dist

build:
  image: {{DOCKER_NODEJS_IMG}}
  stage: build
  rules:
    - if: $CI_COMMIT_BRANCH == "develop" || $CI_COMMIT_BRANCH == "main"
  cache:
    key: $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA
    policy: push
    paths:
      - $CLIENT_PATH
  script:
    - !reference [.common, get_environment]
    - npm install
    - if [[ "$ENV" == "pro" ]]; then BUILD_ENVIRONMENT="production"; else BUILD_ENVIRONMENT="develop"; fi
    - npm run build

deploy:
  stage: deploy
  cache:
    key: $CI_PROJECT_NAME-$CI_COMMIT_SHORT_SHA
    policy: pull
    paths:
      - $CLIENT_PATH
  script:
    - !reference [.common, get_environment]
    - echo aws ssm get-parameter --name "/$ENV/$CUSTOMER_ID/config/components/$COMPONENT_NAME/cloudfront/id"
    - CLOUDFRONT=$(aws ssm get-parameter --name "/$ENV/$CUSTOMER_ID/config/components/$COMPONENT_NAME/cloudfront/id" | jq -r .Parameter.Value)
    - echo aws ssm get-parameter --name "/$ENV/$CUSTOMER_ID/config/components/$COMPONENT_NAME/s3/id"
    - S3_BUCKET=$(aws ssm get-parameter --name "/$ENV/$CUSTOMER_ID/config/components/$COMPONENT_NAME/s3/id" | jq -r .Parameter.Value)
    - rm -rf $CLIENT_PATH/.git || true
    - rm -rf $CLIENT_PATH/.gitlab-ci.yml || true
    - rm -rf $CLIENT_PATH/.gitignore || true
    - echo aws s3 sync --delete $CLIENT_PATH s3://${S3_BUCKET}${COMPONENT_PATH}
    - aws s3 sync --delete $CLIENT_PATH s3://${S3_BUCKET}${COMPONENT_PATH}
    - if [ -f $CLIENT_PATH/index.html ]; then aws s3 cp $CLIENT_PATH/index.html s3://${S3_BUCKET}${COMPONENT_PATH}/index.html --cache-control "no-cache"; fi
    - if [[ "$COMPONENT_PATH" == "/root" ]]; then INVALIDATION_PATH=""; else INVALIDATION_PATH=$COMPONENT_PATH; fi
    - INVALIDATION_ID=$(aws cloudfront create-invalidation --distribution-id ${CLOUDFRONT} --paths "${INVALIDATION_PATH}*" | jq .Invalidation.Id -r)
    - aws cloudfront wait invalidation-completed --distribution-id ${CLOUDFRONT} --id ${INVALIDATION_ID}
